#!/usr/bin/env python3
# -*- coding: utf-8 -*-

#
# (c) Simon Psenner, iteas IT Services GmbH
# simon.psenner@iteas.at
# www.iteas.at
#
import datetime
import json
import os
import subprocess

from flask import Flask, jsonify, request
from flask_restful import reqparse, abort, Api, Resource

app = Flask(__name__)
api = Api(app)


label = """ ^XA^MUm^MFC,L^PW104^LT0^LH0,0^CI28~SD{darkness}^
^FO85,1^BY0.35,2.8^B2R,13,Y,N,Y^FD{barcode}^FS 
^CI28^FO5,5^A0N,10,10^FD{owner}^FS
^CI28^FO68,5^A0N,10,10^FD{country}^FS
^CI28^FO5,22^A0N,6,6^FDPartie: ^FS
^CI28^FO27,20^A0N,10,10^FD{lotnumber}^FS 
^FO3,19^GB75,10,0.2^FS
^CI28^FO20,35^A0N,6,6^FDProd: {suppliernumber}^FS
^CI28^FO55,36^A0N,4,4^FD{ggnr}^FS
^CI28^FO20,42^A0N,10,10^TBN,480,200^FD{suppliername}^FS
^CI28^FO20,65^A0N,6,6^FD{prodnr}^FS
^CI28^FO45,65^A0N,5,5^TBN,290,50^FD{farmnr}  {farmname}^FS
^CI28^FO20,85^A0N,10,10^FD{prodname}^FS
^CI28^FO20,95^A0N,7,7^FD{mutant}^FS
^CI28^FO20,110^A0N,14,14^FD{amount}^FS
^CI28^FO50,115^A0N,7,7^FD{container}^FS
^CI28^FO20,132^A0N,4,4^FD{pressure}^FS
^CI28^FO45,132^A0N,4,4^FD{sugar}^FS
^CI28^FO75,132^A0N,4,4^FD{starch}^FS
^CI28^FO20,138^A0N,5,5^FDEJ {year}^FS
^CI28^FO45,138^A0N,4,4^FDLS-Nr: {lsnr}^FS
^CI28^FO75,138^A0N,4,4^FD{deliverydate}^FS
^CI28^FO20,145^A0N,5,5^FD{certs}^FS
^FO3,50^BY0.60,2.0^BCB,10,Y,N,N^FD{fsscode}^FS
^PQ{quantity}
^XZ """



@app.route('/')
def index():
    return "Hello World!"

# Todo How to deal with multiple Printjobs at a time

class PrintAroma(Resource):
    def post(self):
        data = request.data
        json_data = json.loads(str(data.decode("utf-8")))
        print(json_data)

        printer_darkness = json_data.get("printer_darkness", 20)
        barcode = json_data.get("barcode", "")  # 30000118777000050102040
        owner = json_data.get("owner", "")
        country = json_data.get("country", "")  # AT
        lotnumber = json_data.get("lotnumber", "")  # 1877700005
        suppliernumber = json_data.get("supplier", "")  # 300001
        ggnr = json_data.get("ggnr", "")  # Zertifikatsnumber
        suppliername = json_data.get("suppliername", "")  # Franz Huber
        prodnr = json_data.get("prodnr", "")  # 102

        farmnr = json_data.get("farmnr", "")  # 2548
        farmname = json_data.get("farmname", "")  # Anlage B45

        prodname = json_data.get("prodname", "")  # Idared

        mutant = json_data.get("mutant", "")  # Mutantenname

        amount = json_data.get("amount", "")  # 40
        container = json_data.get("container", "")  # GKP

        certs = json_data.get("certs", "")  # GGAP
        lsnr = json_data.get("lsnr", "")  # Lieferscheinnumber
        year = json_data.get("year", "")  # 2019
        deliverydate = json_data.get("deliverydate", "")  # 02.11.2017

        sugar = str(json_data.get("sugar", ""))
        pressure = str(json_data.get("pressure", ""))
        starch = str(json_data.get("starch", ""))
        fsscode = str(json_data.get("fsscode", ""))
        sugarstr = ""
        pressurestr = ""
        starchstr = ""

        if sugar != "":
            sugarstr = "Zucker: {value} Brix".format(value=sugar)

        if pressure != "":
            pressurestr = "DF: {value} kg".format(value=pressure)

        if starch != "":
            starchstr = "Stärke: {value}".format(value=starch)

        pages = json_data.get("pages", "3")  # 2

        with open("/tmp/aromaout.zpl", "w+") as file:
            file.write(label.format(darkness=printer_darkness, barcode=barcode, owner=owner, country=country, lotnumber=lotnumber, suppliernumber=suppliernumber, ggnr=ggnr, suppliername=suppliername, prodnr=prodnr, farmnr=farmnr, farmname=farmname, prodname=prodname, mutant=mutant, amount=amount, container=container, pressure=pressurestr, sugar=sugarstr, starch=starchstr, year=year, lsnr=lsnr, deliverydate=deliverydate,
                                    certs=certs, fsscode=fsscode, quantity=pages))

        subprocess.call(["lpr -PZebra_ZD420 -o raw /tmp/aromaout.zpl"], shell=True)
        # count = 0
        # while count < pages:
        #    count += 1
        #    print("printing")
        #    subprocess.call(["lpr -PZebra_ZD420 -o raw /tmp/aromaout.zpl"], shell=True)

        return jsonify(message="Printjob Recived")

class PrintTest(Resource):
    def get(self):
        with open("/tmp/testout.zpl", "w+") as file:
            file.write(label.format(darkness="20", barcode="306232105100108104040", owner="AROMA", country="AT", lotnumber="2105100108", suppliernumber="30623", ggnr="4052852518260", suppliername="Zoller Anton und Margit", prodnr="104", farmnr="12", farmname="Obstgarten", prodname="Jonagold", mutant="Reinders", amount="3", container="GK PLASTIK AROMA", pressure="DF: 8,15 kg", sugar="Zucker: 16 Brix", starch="Stärke: 5", year=datetime.datetime.now().year, lsnr="24236", deliverydate=datetime.datetime.now().strftime("%d.%m.%Y"),
                                    certs="GGAP", fsscode="0121700005", quantity="1"))

        subprocess.call(["lpr -PZebra_ZD420 -o raw /tmp/testout.zpl"], shell=True)

api.add_resource(PrintAroma, '/aroma')
#api.add_resource(PrintAroma, '/print')
api.add_resource(PrintTest, '/test')

if __name__ == "__main__":
    app.run(host='0.0.0.0', port=8080, debug=True)
